// Project : K-means
// Author : Dario GENGA

#include "files_utils.h"


FILE* open_file(char *file_path, char *mode) {
    // Open the file
    FILE *file = fopen(file_path, mode);
    if (file == NULL)
    {
        perror("Error while opening the file.\n");
        exit(EXIT_FAILURE);
    }
    return file;
}

int count_file_lines(char *file_path) {
    FILE *file = open_file(file_path, "r");
    int current_line = 0;
    char *line = NULL;
    size_t buffer_size = 0;

    while(getline(&line, &buffer_size, file) != -1) {
        // Count the lines that are not empty
        if (strcmp(line, "\n") != 0) {
            current_line++;
        }
    }

    fclose(file);
    free(line);
    return current_line;
}

void remove_string_trailing_newline(char *str) {
    if (str == NULL)
        return;

    int length = strlen(str);
    if (str[length-1] == '\n')
        str[length-1]  = '\0';
}
